// 完毕：
using System.IO;
using GrapeCity.Documents.Pdf;
using GrapeCity.Documents.Pdf.AcroForms;

namespace DsPdfWeb.Demos
{
    // 此示例展示了如何查找和删除现有签名
    // 来自经过数字签名的 PDF。
    // 查看RemoveSignatureFields以获取删除任何签名的代码
    // 而是签名字段。
    // 本示例中使用的 PDF 是由 TimeSheet 创建的。
    public class RemoveSignatures
    {
        public int CreatePDF(Stream stream)
        {
            var doc = new GcPdfDocument();
            using (var fs = File.OpenRead(Path.Combine("Resources", "PDFs", "TimeSheet.pdf")))
            {
                doc.Load(fs);

                // 字段可以是其他字段的子字段，因此我们使用
                // 迭代整个树的递归方法：
                removeSignatures(doc.AcroForm.Fields);

                // 完毕：
                doc.Save(stream);
                return doc.Pages.Count;

                void removeSignatures(FieldCollection fields)
                {
                    foreach (var f in fields)
                    {
                        if (f is SignatureField sf)
                            sf.Value = null;
                        removeSignatures(f.Children);
                    }
                }
            }
        }
    }
}
